#include <REG164CI.H>
#include <stdio.h>

#define VREF	5			/* Voltage Reference */

void main ( void )  {                     

#ifndef MCB167                        /*  do not initialize if you use Monitor-166     */  
  P3  |= 0x0400;                      /*  SET PORT 3.10 OUTPUT LATCH (TXD)             */
  DP3 |= 0x0400;                      /*  SET PORT 3.10 DIRECTION CONTROL (TXD OUTPUT) */
  DP3 &= 0xF7FF;                      /*  RESET PORT 3.11 DIRECTION CONTROL (RXD INPUT)*/
  S0TIC = 0x80;                       /*  SET TRANSMIT INTERRUPT FLAG                  */
  S0RIC = 0x00;                       /*  DELETE RECEIVE INTERRUPT FLAG                */
  S0BG  = 0x40;                       /*  SET BAUDRATE TO 9600 BAUD                    */
  S0CON = 0x8011;                     /*  SET SERIAL MODE                              */
#endif

/* A/D Converter */
                    
while (1){

/* Init ADC	 */
  ADCON = 0x80;                       /*  Enable A/D converter           	             */
                                      /*	Start Convert on AD0BUSY set			  	       */
 
  ADBSY = 1;	                        /*  Start ADC conversion						             */
  while (ADBSY);                      /*  Wait for conversion							             */

/* Output 0-1023 ADDAT value without using floating-point */
  printf ("ADDAT Value %4u = %01u.%04u Volts\r",
         (unsigned) ADDAT,
         (unsigned) (ADDAT * VREF) >> 10,                          /* Output Integer Portion */
         (unsigned) ((ADDAT * VREF * 10000UL) >> 10UL) % 10000);   /* Output Decimal Portion */            
  }  
}